<?php


namespace app\live\controller;

use app\live\controller\mobile\Live;
use think\facade\Db;
use think\facade\Request;
use think\facade\View;
use vitphp\admin\controller\BaseController;
use app\live\model\Huodong as HuoDongModel;

/**
 * @title 活动管理
 * Class Huodong
 * @package app\live\controller
 */
class Huodong extends BaseController
{
    /**
     * @title 直播活动列表
     */
    public function index()
    {
        $pid = input('pid');
        $livelist = Db::name('live_huodong')->where('pid', $pid)->order('id','desc')->paginate(15);
        $hdurl = Request::domain() . ToUrl('/live/m');
        $lives = $livelist->items();
        foreach($lives as &$item){
            $item['total_gift_fee'] = Db::name('live_gift')->where('pid', $pid)->where('rid', $item['id'])->where('ispay', 1)->sum('fee');
        }

        View::assign([
            'hdurl' => !empty($hdurl) ? $hdurl : '',
//            'livelist' => !empty($livelist) ? $livelist : ''
            'livelist' => $lives,
            'page' => $livelist->render()
        ]);
        return View::fetch();
    }

    /**
     * @title 创建、修改活动
     */
    public function edit()
    {
        $pid = input('pid');
        $id = input('id');
        $op = input('op');
        $live = Db::name('live_huodong')->where(['id' => $id])->find();
        $splist = Db::name('live_splist')->where('pid', $pid)->select();
        if (empty($live)) {
            $live['win_type'] = 1;
        }

        //判断是否post提交
        if (request()->isPost()) {
            $baseData = $this->getParams();

            if (!$id || $op == 'copy') {
                Db::name("live_huodong")->save($baseData);
            } else {
                Db::name('live_huodong')->where('id', $id)->update($baseData);
            }
            $this->success("保存成功！", ToUrl('live/huodong/index'));
        }
        if ($live && isset($live['menu'])) {
            $live['menu'] = json_decode($live['menu'], true);
            $live['gifts'] = json_decode($live['gifts'], true);
        } else {
            $live = [];
            $live['menu'][] = [
                'name' => '互动',
                'status' => 1,
                'type' => 'hudong',
                'hudong' => [
                    'background' => ''
                ],
                'tuwen' => '',
                'link' => '',
                'tanchuang' => [
                    'title' => '',
                    'tip' => '',
                    'image' => '',
                ],
                'video' => []
            ];
        }

        View::assign([
            'live' => !empty($live) ? $live : [
                'win_type' => 1,
                'lll' => 1,
                'xz_type' => 1,
                'stime' => date('Y-m-d H:i:s')
            ],
            'live_json' => json_encode($live),
            'splist' => !empty($splist) ? $splist->toArray() : "",
            'bmlist' => !empty($bmlist) ? $bmlist->toArray() : "",

        ]);
        return View::fetch();
    }

    private function getParams()
    {
        $post = $this->request->post();
        $gifts = $this->getGifts();
        $baseData = [
            'pid' => input('pid'),
            'title' => $post['title'],
            'headimg' => $post['headimg'],
            'stime' => $post['stime'],
            'win_type' => $post['win_type'],
            'menu_style' => $post['menu_style'],
            'hd_jieshao' => $post['hd_jieshao'] ?? '',
            'hd_xiangqing' => $post['hd_xiangqing'] ?? '',
            'miaoshu' => $post['miaoshu'],
            'jiaobiao' => $post['jiaobiao'],
            'lll' => $post['lll'],
            'paixu' => $post['paixu'],
            'is_tuijian' => $post['is_tuijian'],
//            'is_zhiding' => $post['is_zhiding'],
            'xn_pv' => $post['xn_pv'],
            'live_type' => $post['live_type'],
            'live_video' => $post['live_video'],
            'zb_leixing' => $post['zb_leixing'],
            'yyid' => $post['yyid'],
            'bl_url' => $post['bl_url'],
            'playback_bl_url' => $post['playback_bl_url'],
            'index' => $post['index'] ?? 0, // 应该是默认菜单值
            'xz_pass' => $post['xz_pass'],
            'xz_placeholder' => $post['xz_placeholder'],
            'xz_pay' => $post['xz_pay'],
            'xz_placeholder2' => $post['xz_placeholder2'],
            'xz_type' => $post['xz_type'],
            'gifts' => json_encode($gifts, 256),
            'is_open_gift' => $post['is_open_gift'],
//            'tl_address' => $post['tl_address'],
//            'bl_address' => $post['bl_address'],
//            'sc_time' => $post['sc_time']
        ];
        $menuSort = input('menu_sort', [0,1,2,3,4]);
        $menuRange = [0,1,2,3,4];
        $otherMenu = array_diff($menuRange, $menuSort);

        $menu = [];
        foreach($menuSort as $sort){
            $videos0 = get_array_val($post, 'hd_menu_videos_'.$sort, []);
            $videos  = [];
            foreach($videos0 as $v){
                $videos[] = $v;
            }
            $item = [
                'name' => get_array_val($post, 'hd_menu_name_'.$sort),
                'status' => get_array_val($post, 'hd_menu_status_'.$sort),
                'type' => get_array_val($post, 'hd_menu_type_'.$sort),
                'hudong' => [
                    'background' => get_array_val($post, 'hd_menu_hudong_background_'.$sort)
                ],
                'tuwen' => get_array_val($post, 'hd_menu_tuwen_'.$sort),
                'link' => get_array_val($post, 'hd_menu_link_'.$sort),
                'iframe' => [
                    'url' => get_array_val($post, 'hd_menu_iframe_url_'.$sort)
                ],
                'tanchuang' => [
                    'title' => get_array_val($post, 'hd_menu_tanchuang_title_'.$sort),
                    'tip' => get_array_val($post, 'hd_menu_tanchuang_tip_'.$sort),
                    'image' => get_array_val($post, 'hd_menu_tanchuang_image_'.$sort),
                ],
                'video' => $videos
            ];
            $item['status'] = $item['name'] ? 1 : 0;
            $menu[] = $item;
        }
        foreach($otherMenu as $other){
            $videos0 = get_array_val($post, 'hd_menu_videos_'.$sort, []);
            $videos  = [];
            foreach($videos0 as $v){
                $videos[] = $v;
            }
            $item = [
                'name' => get_array_val($post, 'hd_menu_name_'.$other),
                'status' => get_array_val($post, 'hd_menu_status_'.$other),
                'type' => get_array_val($post, 'hd_menu_type_'.$other),
                'hudong' => [
                    'background' => get_array_val($post, 'hd_menu_hudong_background_'.$other)
                ],
                'tuwen' => get_array_val($post, 'hd_menu_tuwen_'.$other),
                'link' => get_array_val($post, 'hd_menu_link_'.$other),
                'iframe' => [
                    'url' => get_array_val($post, 'hd_menu_iframe_url_'.$other)
                ],
                'tanchuang' => [
                    'title' => get_array_val($post, 'hd_menu_tanchuang_title_'.$sort),
                    'tip' => get_array_val($post, 'hd_menu_tanchuang_tip_'.$sort),
                    'image' => get_array_val($post, 'hd_menu_tanchuang_image_'.$sort),
                ],
                'video' => $videos
            ];
            $item['status'] = $item['name'] ? 1 : 0;
            $menu[] = $item;
        }
        $baseData['menu'] = json_encode($menu);

        return $baseData;
    }

    /**
     * @title 设置幻灯片
     */
    private function getGifts()
    {
        $gifts = [];
        $giftImg = input('gift_img');
        $giftName = input('gift_name');
        $giftPrice = input('gift_price');
        if(!$giftImg) return $gifts;
        foreach($giftImg as $k => $img){
            if(!$img) $this->error('请上传幻灯片图片');
            $name = $giftName[$k] ?? '';
            if(!$name) $this->error('请填写礼物名称');
            $price = $giftPrice[$k] ?? '';
            if(!$price) $this->error('请填写礼物价格');
            $gifts[] = [
                'name' => $name,
                'price' => $price,
                'img' => $img
            ];
        }
        return $gifts;
    }

    /**
     * @title 删除活动
     */
    public function del()
    {
        $ids = $this->request->post('ids');
        $query = Db::name('live_huodong')->where('id', $ids)->delete();
        $this->success('删除成功');
    }

    public function tanchuang()
    {
        $pid = input('pid');
        $id = input('id');
        $type = input('type');
        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->find();

        $pushUrl = '';
        if ($live['live_type'] == 2 && $live['zb_leixing'] == 2) {
            $aliyunVideoUrls = (new \app\live\controller\mobile\Live)->getAliyunLiveUrls($live['id']);
            $pushUrl = $aliyunVideoUrls['pushurl'];
        }

        $domain = Request::domain();
        View::assign([
            'push_url' => $pushUrl,
            'push_img_url' => $domain . '/index/common/Cqrcode?url=' . $pushUrl,
            'type' => !empty($type) ? $type : '1',
            'live' => $live
        ]);
        return View::fetch();
    }
    public function chats(){
        $pid = input('pid');
        $id = input('id');
        $pageNum = 50;
        $chat = Db::name('live_chat')->where(['pid'=>$pid,'hid'=>$id])->order('id','DESC')->paginate($pageNum);
        //halt($chat);exit();
        View::assign([
           'chat'=>$chat,
           'page' => $chat->render(),
        ]);
        return View::fetch();
    }
    /**
     * @title 删除聊天内容
     */
    public function delchat(){
        $ids = $this->request->post('ids');

        if(is_array($ids)){
             Db::name('live_chat')->where('id', 'in', $ids)->delete();
        }else{
             Db::name('live_chat')->where('id',$ids)->delete();
        }

        $this->success('删除成功');
    }
}