<?php


namespace app\live\controller;


use think\facade\Db;
use think\facade\Request;
use think\facade\View;

class Index
{
    public function index(){
        $pid = input('pid');
        $pageNum = 5;
        $index = Db::name('live_pcsetup')->where('pid',$pid)->find();
        $live = Db::name('live_huodong')->where('pid',$pid)->order('is_tuijian desc, id desc')->page(1, $pageNum)->select()->toArray();

        $subSql = Db::name('live_ztvideolist')->field('ztid, count(ztid) zt_video_count')->group('ztid')->buildSql();

        $zhuanti = Db::name('live_zhuanti')->where('pid',$pid)->alias('z')->field('z.*, v.zt_video_count')
            ->leftJoin([$subSql => 'v'], 'z.id = v.ztid')->page(1, $pageNum)->order('z.is_tuijian desc, z.id desc')->select();
        $zhuanti = $zhuanti->isEmpty() ? [] : $zhuanti->toArray();
        foreach ($zhuanti as &$item) {
            $item['zt_video_count'] = $item['zt_video_count'] ?: 0;
        }

        if($index){
            $index['hdp'] = json_str_to_array($index['hdp']);
        }
        foreach ($live as &$v) {
            $v['pv'] = $v['pv'] ? $v['pv'] : 1;
            $v['pv'] = $v['lll'] == 2 ? $v['pv'] * $v['xn_pv'] : $v['pv'] + $v['xn_pv'];
            if ($v['pv'] > 10000) {
                $v['pv'] = sprintf("%.2f", $v['pv'] / 10000) . '万';
            }
        }

        $thisUrl = Request::domain() . Request::url();
        $weixinConfig = Db::name('live_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $weixinConfig['appsecret'],
            'appid' => $weixinConfig['appid'],
        ];
        $scriptWechat = new \WeChat\Script($config);
        $wechatShareConfig = $scriptWechat->getJsSign($thisUrl);
        $jsApiList = '';
        foreach ($wechatShareConfig['jsApiList'] as $jsApi) {
            $jsApiList .= '"' . $jsApi . '",';
        }
        $pcSetup = Db::name('live_pcsetup')->where(['pid' => $pid])->find();

        $preg = "/http[s]?:\/\/[\w.]+[\w\/]*[\w.]*\??[\w=&\+\%]*/is";
        $pcSetup['fximg'] = media($pcSetup['fximg'], 'act');
        if (!preg_match($preg, $pcSetup['fximg'])) {
            $pcSetup['fximg'] = $pcSetup['fximg'] ? Request::domain() . $pcSetup['fximg'] : '';
        }
        $wechatShare = [
            'title' => $pcSetup['title'],
            'desc' => $pcSetup['share_desc'],
            'link' => $thisUrl,
            'imgUrl' => $pcSetup['fximg']
        ];

        View::assign([
           'index'=>!empty($index)?$index:'',
           'live'=>!empty($live)?$live:'',
           'livel'=>!empty($live)?$live:'',
           'zhuanti'=>!empty($zhuanti)?$zhuanti:'',
           'wechatShare' => $wechatShare,
           'wechatShareConfig' => $wechatShareConfig,
           'jsApiList' => $jsApiList,
        ]);
        return View::fetch();
    }

    public function liveList()
    {
        $pid = input('pid');
        $page = input('page', 1);
        $pageNum = 5;
        $lives = Db::name('live_huodong')->where('pid',$pid)->order('is_tuijian desc, id desc')->page($page, $pageNum)->select()->toArray();
        foreach ($lives as &$v) {
            $v['pv'] = $v['pv'] ? $v['pv'] : 1;
            $v['pv'] = $v['lll'] == 2 ? $v['pv'] * $v['xn_pv'] : $v['pv'] + $v['xn_pv'];
            if ($v['pv'] > 10000) {
                $v['pv'] = sprintf("%.2f", $v['pv'] / 10000) . '万';
            }
        }
        return json([
            'code' => 1,
            'data' => $lives
        ]);
    }

    public function zhuantiList()
    {
        $pid = input('pid');
        $page = input('page', 1);
        $pageNum = 5;

        $subSql = Db::name('live_ztvideolist')->field('ztid, count(ztid) zt_video_count')->group('ztid')->buildSql();

        $zhuanti = Db::name('live_zhuanti')->where('pid',$pid)->alias('z')->field('z.*, v.zt_video_count')
            ->leftJoin([$subSql => 'v'], 'z.id = v.ztid')->order('z.is_tuijian desc, z.id desc')->page($page, $pageNum)->select();
        $zhuanti = $zhuanti->isEmpty() ? [] : $zhuanti->toArray();
        foreach ($zhuanti as &$item) {
            $item['zt_video_count'] = $item['zt_video_count'] ?: 0;
        }

        return json([
            'code' => 1,
            'data' => $zhuanti
        ]);
    }
}