<?php


namespace app\live\controller;

use think\facade\Db;
use think\facade\Request;
use think\facade\View;
use vitphp\admin\controller\BaseController;

/**
 * @title 专题管理
 * Class Zhuanti
 * @package app\live\controller
 */
class Zhuanti extends BaseController
{
    /**
     * @title 专题列表
     */
    public function index(){
        $pid = input('pid');
        $zhuanti = Db::name('live_zhuanti')->where('pid',$pid)->select()->all();
        $hdurl = Request::domain().ToUrl('/live/zt');
        View::assign([
            'hdurl'=>!empty($hdurl)?$hdurl:'',
           'zhuanti'=>!empty($zhuanti)?$zhuanti:'',
        ]);
        return View::fetch();
    }
    /**
     * @title 创建修改专题
     */
    public function ztedit(){
        $pid = input('pid');
        $id = input('id');
        $zhuanti = Db::name('live_zhuanti')->where(['id'=>$id])->find();
        if(request()->isPost()){
            $param = [
                'title'=>input('title'),
                'share_desc'=>input('share_desc'),
                'share_icon'=>input('share_icon'),
                'paixu'=>input('paixu'),
                'is_tuijian'=>input('is_tuijian'),
                'jieshao'=>input('jieshao'),
                'pid'=>$pid
            ];
            if ($id){
                $res = Db::name('live_zhuanti')->where('id',$id)->update($param);
            }else{
                $res = Db::name("live_zhuanti")->save($param);
            }
            if($res){
                $this->success("保存成功！", ToUrl('live/zhuanti/index'));
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'zhuanti'=>!empty($zhuanti)? $zhuanti: '',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除专题
     */
    public function ztdel(){
        $ids = $this->request->post('ids');
        $query = Db::name('live_zhuanti')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 专题分类
     */
    public function type(){
        $pid = input('pid');
        $ztid = input('ztid');
        $type = Db::name('live_zttype')->where(['pid'=>$pid,'ztid'=>$ztid])->select()->toArray();
        View::assign([
           'type'=>!empty($type)?$type:'',
        ]);
        return View::fetch();
    }
    /**
     * @title 添加、编辑专题分类
     */
    public function fledit(){
        $pid = input('pid');
        $ztid = input('ztid');
        $id = input('id');
        $zttype = Db::name('live_zttype')->where(['id'=>$id])->find();
        if(request()->isPost()){
            $param = [
                'name'=>input('name'),
                'pid'=>input('pid'),
                'ztid'=>input('ztid'),
            ];
            if ($id){
                $res = Db::name('live_zttype')->where('id',$id)->update($param);
            }else{
                $res = Db::name("live_zttype")->save($param);
            }
            if($res){
                $this->success("保存成功！", ('live/zhuanti/type?pid=').$pid."&ztid=".$ztid);
            }else{
                $this->error("保存失败！");
            }
        }
        View::assign([
            'zttype'=>!empty($zttype)?$zttype:'',
        ]);
        return View::fetch();
    }
    /**
     * @title 删除分类
     */
    public function fldel(){
        $ids = $this->request->post('ids');
        $query = Db::name('live_zttype')->where('id',$ids)->delete();
        if ($query){
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }
    /**
     * @title 添加视频
     */
    public function spedit(){
        $pid = input('pid');
        $ztid = input('ztid');
        $flid = input('flid');
        $huodong = Db::name('live_huodong')->where('pid',$pid)->select()->toArray();
        $where = [
            ['pid', '=', $pid],
            ['ztid', '=', $ztid],
            ['flid', '=', $flid]
        ];
        $dbZtVideoHids = Db::name('live_ztvideolist')->where($where)->column('hid');

        if(request()->isPost()){
            $hid = input('hid');
            $removeHids = $hid ? array_diff($dbZtVideoHids, $hid) : $dbZtVideoHids;
            $addHids = $hid ? array_diff($hid, $dbZtVideoHids) : $hid;
            if($removeHids){
                Db::name('live_ztvideolist')->where(array_merge($where, [['hid', 'in', $removeHids]]))->delete();
            }
            if($addHids){
                $createData = [];
                foreach($addHids as $aHid){
                    $createData[] = [
                        'pid' => $pid,
                        'ztid' => $ztid,
                        'flid' => $flid,
                        'hid' => $aHid
                    ];
                }
                Db::name('live_ztvideolist')->insertAll($createData);
            }

            return json(['code'=>1, 'msg'=>'添加成功']);
        }

        View::assign([
            'huodong'=>!empty($huodong)?$huodong:'',
            'dbZtVideoHids'=>$dbZtVideoHids,
        ]);
        return View::fetch();
    }
}