<?php


namespace app\live\controller\mobile;

use think\facade\Db;
use think\facade\View;
use think\facade\Log;
use think\facade\Request;

class Live extends Base
{
    public function index()
    {
        $id = input('id');
        $pid = input('pid');
        $uid = input('uid', null);
        $spid = input('spid', '');

        $isMobile = $this->isMobile();
        $isWechat = $this->isWechat();
        if(!$isWechat && !$isMobile){
            $pcUrl = $spid!=='' ? url('mobile.pc/index', ['pid' => $pid, 'id' => $id, 'spid'=>$spid])->build() :
                url('mobile.pc/index', ['pid' => $pid, 'id' => $id])->build();
            return redirect($pcUrl);
        }

        $wechatInfo = vit_session('user_wechat');
        $thisUrl = Request::scheme() . '://' . Request::host() . Request::url();
        $weixinConfig = Db::name('live_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $weixinConfig['appsecret'],
            'appid' => $weixinConfig['appid'],
        ];
        $scriptWechat = new \WeChat\Script($config);
        $wechatShareConfig = $scriptWechat->getJsSign($thisUrl);
        $jsApiList = '';
        foreach ($wechatShareConfig['jsApiList'] as $jsApi) {
            $jsApiList .= '"' . $jsApi . '",';
        }

//        $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $wechatInfo['openid']])->find();
////        $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => 'oYeHN0fV_2ZifY3ljKT5fzfq9zvk'])->find();
//        if (!$guest) {
//            Db::name('live_guest')->insert([
//                'pid' => $pid,
//                'hid' => $id,
//                'sid' => $uid,
//                'openid' => $wechatInfo['openid'],
//                'avatar' => $wechatInfo['headimgurl'],
//                'nickname' => $wechatInfo['nickname'],
//                'time' => time(),
//            ]);
//        }
        $guest = $this->getGuestInfo($wechatInfo);

        $paihang = Db::name('live_guest')->field('count(sid) as count_sid,sid')->where([
            ['sid', '>', 0], ['pid', '=', $pid], ['hid', '=', $id],
        ])->group('sid')->order('count_sid desc')->page(1, 20)->select();

        if (!$paihang->isEmpty()) {
            $paihang = $paihang->toArray();
        }
        foreach ($paihang as &$v) {
            $itemGuest = Db::name('live_guest')->where('id', '=', $v['sid'])->field('nickname,avatar')->find();
            $v['nickname'] = $this->userTextDecode($itemGuest['nickname']);
            $v['avatar'] = $itemGuest['avatar'];

            if (mb_strlen($v['nickname'], 'utf-8') > 8) {
                $str = mb_substr($v['nickname'], 0, 8, 'utf-8');
                $v['nickname'] = $str . '..';
            }
        }

        $tabTypes = ['splist', 'tanchuang'];
        Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->inc('pv')->update();
        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->find();

        if ($live) {
            $spidVideo = '';

            $live['jiaobiao'] = $this->getFullMediaUrl($live['jiaobiao']);
            $live['gifts'] = $live['gifts'] ? json_decode($live['gifts'], true) : [];
            $live['menuArray'] = json_decode($live['menu'], true);
            $live['pv'] = $live['pv'] ? $live['pv'] : 1;
            $pv = $live['lll'] == 2 ? $live['pv'] * $live['xn_pv'] : $live['pv'] + $live['xn_pv'];
            if ($pv > 10000) {
                $pv = sprintf("%.2f", $pv / 10000) . '万';
            }
            $thisDomain = Request::scheme() . '://' . Request::host();
            $videos = [];
            $hudongBackground = '';
            foreach ($live['menuArray'] as &$menu) {
                if (!isset($menu['data'])) {
                    $menu['data'] = '';
                }
                if ($menu['type'] == 'splist') {
                    $videos = $menu['video'];
                    foreach ($videos as $k => &$video) {
                        $video['video'] = $video['url'];
                        $video['url'] = $thisDomain . url('mobile.live/index', ['pid' => $pid, 'id' => $id, 'uid' => $guest['id'], 'spid' => $k])->build();
                        if ($spid !== '' && $spid == $k) {
                            $spidVideo = $video['video'];
                        }
                    }
                }
                if($menu['type'] == 'hudong' && $menu['hudong']){
                   $hudongBackground = get_array_val($menu, 'hudong.background');
                }
            }
            $activeTableIndex = isset($live['index']) ? $live['index'] : 0;

            $liveVideoUrl = $this->getLiveUrl($live);
            if ($spid !== '') {
                $shareLink = $thisDomain . url('mobile.live/index', ['pid' => $pid, 'id' => $id, 'uid' => $guest['id'], 'spid' => $spid])->build();
            } else {
                $shareLink = $thisDomain . url('mobile.live/index', ['pid' => $pid, 'id' => $id, 'uid' => $guest['id']])->build();
            }

            $wechatShare = [
                'title' => $live['title'],
                'desc' => $live['miaoshu'],
                'link' => $shareLink,
                'imgUrl' => $live['headimg']
            ];

            $xzType = 1;
            if ($live['xz_type'] == 2 && $guest['xz_password'] != $live['xz_pass']) {
                $xzType = 2;
            }
            if ($live['xz_type'] == 3 && $guest['xz_fee_status'] != 1) {
                $xzType = 3;
            }
            View::assign([
                'wechatShareConfig' => $wechatShareConfig,
                'jsApiList' => $jsApiList,
                'wechatShare' => $wechatShare,
                'hudongBackground' => $hudongBackground,
                'videos' => $videos,
                'paihang' => $paihang,
                'pv' => $pv,
                'xzType' => $xzType,
                'live' => $live,
                'live_video_url' => $spidVideo ? $spidVideo : $liveVideoUrl,
                'tabTypes' => $tabTypes,
                'activeTableIndex' => $activeTableIndex,
                'test' => [
                    'live_title' => $live['title'],
                    'fg_color' => '#000',
                    'bg_image' => $live['headimg'],
                    'zb_time' => strtotime($live['stime']),
                    'zb_status' => (int)$live['live_type'] + 1,
                    'shareimg' => '',
                    'gonggao' => '',
                    'isshowhaibao' => '',
                    'cover' => '',
                    'jiaobiao' => ''
                ],
                'zb_look_xz' => [
                    'xianzhi_type' => 1,
                    'xz_password' => $live['xz_pass'],
                    'xz_tishi' => '',
                    'xz_price' => 0
                ],
                'guest' => [
                    'xz_password' => input('xz_password')
                ],
                'Pv' => 0,
                'queryGuest' => [],
                'config' => [],
                'ds_giftdata' => [
                    'ds_isshowgift' => 1
                ],
                'addatahdp' => [],
                'jieshao' => '',
                'xiangqing' => '',
                'ds_giftinfo' => []
            ]);
        }

        return View::fetch();
    }

    public function getChatList()
    {
        $id = input('id');
        $pid = input('pid');
        $page = input('page', 1);
        $num = input('num', 15);

        $chartField = ['time', 'avatar', 'nickname', 'content', 'type'];
        $chats = Db::name('live_chat')->where(['pid' => $pid, 'hid' => $id])->field($chartField)->page($page, $num)->order('id desc')->select();
        if (!$chats->isEmpty()) {
            $chats = $chats->toArray();
        }
        foreach ($chats as &$chat) {
            $chat['timestamp'] = $chat['time'];
            if(date('Y')==date('Y', $chat['time'])){
                $chat['time'] = date('m-d H:i:s', $chat['time']);
            }else{
                $chat['time'] = date('Y-m-d H:i:s', $chat['time']);
            }
            $chat['nickname'] = $this->userTextDecode($chat['nickname']);
        }
        return json(['code' => 1, 'data' => $chats]);
    }

    /**
     * 根据活动配置，获取视频地址
     * 按说应该拆一个逻辑层出来，这里没有，就在这写吧
     */
    public function getLiveUrl($live)
    {
        $liveVideoUrl = '';
        if ($live['live_type'] == 1) {
            $liveVideoUrl = $live['live_video'];
        } else if ($live['live_type'] == 2) {
            if ($live['zb_leixing'] == 1) {
                $liveVideoUrl = $this->getYYLiveUrl($live['yyid']);
            } else if ($live['zb_leixing'] == 2) {
                $aliyunVideoUrls = $this->getAliyunLiveUrls($live['id']);
                $liveVideoUrl = $aliyunVideoUrls['m3u8url'];
            } else {
                $liveVideoUrl = $live['bl_url'];
            }
        } else {
            $liveVideoUrl = $live['playback_bl_url'];
        }

        return $liveVideoUrl;
    }

    /**
     * 通过房间号，获取YY直接拉流地址
     * @param $sid
     * @return mixed
     */
    public function getYYLiveUrl($sid)
    {
        $loginurl = 'http://interface.yy.com/hls/get/0/' . $sid . '/' . $sid . '?appid=0&excid=1200&type=m3u8&isHttps=0&callback=jsonp2';
        $result = app_http_request($loginurl, null, [], [
            'CURLOPT_REFERER' => 'http://wap.yy.com/mobileweb/' . $sid . '/' . $sid . '?tempId=' . $sid . ''
        ], true);
        $result = json_decode(substr($result, 7, -1), true);
        if(!$result) return '';
        if ($result['code'] == 0) {
            $hls = isset($result['hls']) ? $result['hls'] : '';
        } else {
            $hls = '';
        }
        return $hls;
    }

    /**
     * 通过房间号，生成阿里云用到的推流与拉流地址
     * @param $sid
     */
    public function getAliyunLiveUrls($sid)
    {
        $setup = Db::name('live_setup')->where('pid', '=', 8)->find();
        $DomainName = $setup['DomainName']; // 播流域名
        $PushFlow = $setup['PushFlow'];//推流域名
        $AppName = $setup['appname'];
        $StreamName = $sid;

        $time = time() + 1800;
        $key = $setup['AuthMainKey'];
        $boliukey = $setup['boliukey'];
        $strpush = "/$AppName/$StreamName-$time-0-0-$key";
        $pushurl = "rtmp://" . $PushFlow . "/$AppName/$StreamName?auth_key=$time-0-0-" . md5($strpush);

        $strviewrtmp = "/$AppName/$StreamName-$time-0-0-$boliukey";
        $strviewflv = "/$AppName/$StreamName.flv-$time-0-0-$boliukey";
        $strviewm3u8 = "/$AppName/$StreamName.m3u8-$time-0-0-$boliukey";

        $rtmpurl = "rtmp://" . $DomainName . "/$AppName/$StreamName?auth_key=$time-0-0-" . md5($strviewrtmp);
        $flvurl = 'http://' . $DomainName . "/$AppName/$StreamName.flv?auth_key=$time-0-0-" . md5($strviewflv);
        $m3u8url = 'http://' . $DomainName . "/$AppName/$StreamName.m3u8?auth_key=$time-0-0-" . md5($strviewm3u8);

        $data['pushurl'] = $pushurl; // 推流地址
        $data['m3u8url'] = $m3u8url; //播放地址
        $data['rtmpurl'] = $rtmpurl; //播放地址
        $data['flvurl'] = $flvurl; //播放地址
        return $data;
    }

    public function chat()
    {
        $content = input('content');
        $pid = input('pid');
        $id = input('id');
        $type = 1;
        $wechatInfo = vit_session('user_wechat');
        if (!$wechatInfo) {
            return json(['code' => -1, 'msg' => '请先登录']);
        }
        $guest = $this->getGuestInfo($wechatInfo);
//        $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $wechatInfo['openid']])->find();
        $resData = [
            'pid' => $pid,
            'avatar' => $wechatInfo['headimgurl'],
            'nickname' => $wechatInfo['nickname'],
            'hid' => $id,
            'content' => $content,
            'time' => time(),
            'type' => $type,
        ];
        $insertData = [
            'openid' => $wechatInfo['openid'],
            'uid' => isset($guest['id']) ? $guest['id'] : 0,
        ];
        Db::name('live_chat')->insert(array_merge($insertData, $resData));

        $resData['timestamp'] = time();
        $resData['time'] = date('m-d H:i:s');
        return json(['code' => 1, 'data' => $resData]);
    }

    public function inputPassword()
    {
        $id = input('id');
        $pid = input('pid');
        $pass = input('pass');

        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->find();
        if ($pass != $live['xz_pass']) {
            return json(['code' => -1, 'msg' => '密码不正确！']);
        }

        $wechatInfo = vit_session('user_wechat');
        Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $wechatInfo['openid']])->update([
            'xz_password' => $pass
        ]);

        return json(['code' => 1, 'msg' => '验证成功']);
    }

    public function up()
    {
        $pid = input('pid');
        $id = input('id');
        $wechatInfo = vit_session('user_wechat');
        if (!$wechatInfo) {
            return json(['code' => -1, 'msg' => '请先登录']);
        }
        Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->inc('up')->update();
        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->field(['id,up'])->find();

        return json([
            'code' => 1,
            'data' => [
                'num' => $live['up']
            ]
        ]);
    }
}