<?php


namespace app\live\controller\mobile;

use think\facade\Db;
use think\facade\Request;
use think\facade\View;

class Pc extends Base
{
    public function index()
    {
        $mobileLive = new Live(app());
        $id = input('id');
        $pid = input('pid');
        $spid = input('spid', '');
        $thisUrl = Request::url(true);
        $isWechat = $this->isWechat();
        if($isWechat){
            $mobileUrl = $spid!=='' ? url('mobile.live/index', ['pid' => $pid, 'id' => $id, 'spid'=>$spid])->build() :
                    url('mobile.live/index', ['pid' => $pid, 'id' => $id])->build();
            return redirect($mobileUrl);
        }

        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->find();
        $thisDomain = Request::scheme() . '://' . Request::host();
        Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->inc('pv')->update();

        $guest = null;
        $wechatInfo = vit_session('user_wechat');
        if($wechatInfo){
            $guest = $this->getGuestInfo($wechatInfo);
//            $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $wechatInfo['openid']])->find();
//            if (!$guest) {
//                Db::name('live_guest')->insert([
//                    'pid' => $pid,
//                    'hid' => $id,
//                    'openid' => $wechatInfo['openid'],
//                    'avatar' => $wechatInfo['headimgurl'],
//                    'nickname' => $wechatInfo['nickname'],
//                    'time' => time(),
//                ]);
//            }
        }

        $liveVideoUrl = $mobileLive->getLiveUrl($live);

        $paihang = Db::name('live_guest')->field('count(sid) as count_sid,sid')->where([
            ['sid', '>', 0], ['pid', '=', $pid], ['hid', '=', $id],
        ])->group('sid')->order('count_sid desc')->page(1, 20)->select();

        if (!$paihang->isEmpty()) {
            $paihang = $paihang->toArray();
        }
        foreach ($paihang as &$v) {
            $itemGuest = Db::name('live_guest')->where('id', '=', $v['sid'])->field('nickname,avatar')->find();
            $v['nickname'] = $this->userTextDecode($itemGuest['nickname']);
            $v['avatar'] = $itemGuest['avatar'];

            if (mb_strlen($v['nickname'], 'utf-8') > 8) {
                $str = mb_substr($v['nickname'], 0, 8, 'utf-8');
                $v['nickname'] = $str . '..';
            }
        }

        // 处理观看限制
        $xzType = 1;
        if ($live['xz_type'] == 2 && $live['xz_pass']) {
            $guestPwd = vit_session('live_' . $live['id'] . '.xz_pass');
            $xzType = $guestPwd == $live['xz_pass'] ? $xzType : 2;
            if($guest){
                $xzType = $guest['xz_password'] != $live['xz_pass'] ? 2 : 1;
            }
        }
        if ($live['xz_type'] == 3 ) {
            if($guest){
                $xzType = $guest['xz_fee_status'] == 1 ? $xzType : 3;
            }else{
                $xzType = 3;
            }

        }
        $tabTypes = ['splist', 'tanchuang'];
        $live['pv'] = $live['pv'] ? $live['pv'] : 1;
        $pv = $live['lll'] == 2 ? $live['pv'] * $live['xn_pv'] : $live['pv'] + $live['xn_pv'];
        if ($pv > 10000) {
            $pv = sprintf("%.2f", $pv / 10000) . '万';
        }
        $live['jiaobiao'] = $this->getFullMediaUrl($live['jiaobiao']);
        $live['menuArray'] = json_decode($live['menu'], true);
        $videos = [];
        $spidVideo = '';
        $hudongBackground = '';
        foreach ($live['menuArray'] as &$menu) {
            if (!isset($menu['data'])) {
                $menu['data'] = '';
            }
            if ($menu['type'] == 'splist') {
                $videos = $menu['video'];
                foreach ($videos as $k => &$video) {
                    $video['video'] = $video['url'];
                    $video['url'] = $thisDomain . url('mobile.pc/index', ['pid' => $pid, 'id' => $id, 'spid' => $k])->build();
                    if ($spid !== '' && $spid == $k) {
                        $spidVideo = $video['video'];
                    }
                }
            }
            if ($menu['type'] == 'hudong' && $menu['hudong']) {
                $hudongBackground = get_array_val($menu, 'hudong.background');
            }
        }
        $activeTableIndex = isset($live['index']) ? $live['index'] : 0;

        View::assign([
            'live' => !empty($live) ? $live : '',
            'videoUrl' => $spidVideo ? $spidVideo : $liveVideoUrl,
            'guest' => $guest,
            'hudongBackground' => $hudongBackground,
            'pv' => $pv,
            'xzType' => $xzType,
            'tabTypes' => $tabTypes,
            'activeTableIndex' => $activeTableIndex,
            'paihang' => $paihang,
            'videos' => $videos,
            'mobileUrl' => $thisUrl,
        ]);
        return View::fetch();
    }

    public function inputPassword()
    {
        $id = input('id');
        $pid = input('pid');
        $pass = input('pass');

        $live = Db::name('live_huodong')->where(['pid' => $pid, 'id' => $id])->find();
        if ($pass != $live['xz_pass']) {
            return json(['code' => -1, 'msg' => '密码不正确！']);
        }

        // 判断是否登录，登录了就要更新表，否则就只更新vit_session
        $wechatInfo = vit_session('user_wechat');
        if($wechatInfo){
            Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $wechatInfo['openid']])->update([
                'xz_password' => $pass
            ]);
        }else{
            vit_session('live_' . $live['id'] . '.xz_pass', $pass);
        }

        return json(['code' => 1, 'msg' => '验证成功']);
    }

    public function loginOut()
    {
        vit_session('user_wechat', null);
        return json(['code' => 1, 'msg' => '退出成功']);
    }
    
    public function login()
    {
        $code = input('login_code');
        $pid = input('pid');
        $loginTimeOut = 120;

        if (Request::isPost()) {
            if (!$code) return json(['code' => -1, 'msg' => '非法操作']);

            $loginInfo = Db::name('live_scan_login')->where('code', '=', $code)->find();
            if (!$loginInfo) return json(['code' => -1, 'msg' => '非法操作!']);
            if ($loginInfo['state'] == 1) return json(['code' => -1, 'msg' => '您已登录，无需重复登录']);
            if ((time() - $loginInfo['create_time']) > $loginTimeOut) return json(['code' => -1, 'msg' => '登录超时']);

            // 获取用户登录的id
            $wechatInfo = vit_session('user_wechat');
            Db::name('live_scan_login')->where('id', '=', $loginInfo['id'])->update([
                'openid' => $wechatInfo['openid'],
                'avatar' => $wechatInfo['headimgurl'],
                'nickname' => $this->userTextEncode($wechatInfo['nickname']),
                'state' => 1,
                'update_time' => time()
            ]);
            return json(['code' => 1, 'msg' => '登录成功']);
        }

        View::assign([
            'code' => $code
        ]);
        return View::fetch();
    }

    /**
     * 生成扫码登录用的二维码
     */
    public function scanLoginEwm()
    {
        $code = md5(uniqidDate(30));
        $pid = input('pid');
        $url = Request::domain() . url('mobile.pc/login', ['login_code' => $code, 'pid'=> $pid])->build();
        $src = '/index/common/Cqrcode?url=' . urlencode($url);
        Db::name('live_scan_login')->insert([
            'code' => $code,
            'create_time' => time(),
            'update_time' => time()
        ]);

        return json([
            'code' => 1,
            'data' => [
                'code' => $code,
                'src' => $src
            ]
        ]);
    }

    /**
     * 查找登录结果
     */
    public function scanLogin()
    {
        $code = input('code');
        $pid = input('pid');
        $id = input('id');
        if (!$code) return json(['code' => -1, 'msg' => 'code为空']);

        $loginTimeOut = 120;
        $loginInfo = Db::name('live_scan_login')->where('code', '=', $code)->find();
        if (!$loginInfo) return json(['code' => -1, 'msg' => '不存在的登录信息']);
        if ((time() - $loginInfo['create_time']) > $loginTimeOut) {
             return json(['code' => -1, 'msg' => '登录超时']);
        }

        if ($loginInfo['state'] == 1) {
            // 通过openid找guest，如果没信息就新建
            $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $loginInfo['openid']])->find();
            if (!$guest) {
                Db::name('live_guest')->insert([
                    'pid' => $pid,
                    'hid' => $id,
                    'openid' => $loginInfo['openid'],
                    'avatar' => $loginInfo['avatar'],
                    'nickname' => $this->userTextEncode($loginInfo['nickname']),
                    'time' => time(),
                ]);
                $guest = Db::name('live_guest')->where(['pid' => $pid, 'hid' => $id, 'openid' => $loginInfo['openid']])->find();
            }
            vit_session('user_wechat', [
                'openid' => $guest['openid'],
                'headimgurl' => $guest['avatar'],
                'nickname' => $guest['nickname'],
            ]);

            return json([
                'code' => 1,
                'data' => [
                    'status' => 1,
                ]
            ]);
        } else {
            return json([
                'code' => 1,
                'data' => [
                    'status' => 0,
                ]
            ]);
        }
    }
}