<?php


namespace app\live\controller\mobile;

use think\facade\Request;
use think\facade\Db;
use think\facade\View;

class Zhuanti extends Base
{
    public function index()
    {
        $id = input('id');
        $pid = input('pid');

        $thisDomain = Request::scheme() . '://' . Request::host();
        $thisUrl = $thisDomain . Request::url();
        $weixinConfig = Db::name('live_weixin')->where(['pid' => $pid])->find();
        $config = [
            'appsecret' => $weixinConfig['appsecret'],
            'appid' => $weixinConfig['appid'],
        ];
        $scriptWechat = new \WeChat\Script($config);
        $wechatShareConfig = $scriptWechat->getJsSign($thisUrl);
        $jsApiList = '';
        foreach($wechatShareConfig['jsApiList'] as $jsApi){
            $jsApiList .= '"'.$jsApi.'",';
        }

        $zhuanti = Db::name('live_zhuanti')->where(['pid' => $pid, 'id' => $id])->find();

        $wechatShare = [
            'title' => $zhuanti['title'],
            'desc' => $zhuanti['share_desc'],
            'link' => $thisDomain . url('mobile.zhuanti/index', ['pid'=>$pid,'id'=>$id])->build(),
            'imgUrl' => $this->getFullMediaUrl($zhuanti['share_icon'])
        ];

        $fenlei = Db::name('live_zttype')->where(['pid' => $pid, 'ztid' => $id])->select()->toArray();
        $fenleiIds = array_column($fenlei, 'id');
        $ztVideoWhere = [
            ['z.pid', '=', $pid],
            ['z.ztid', '=', $id],
            ['z.flid', 'in', $fenleiIds]
        ];
        $ztVideoList = Db::name('live_ztvideolist')->alias('z')->where($ztVideoWhere)
            ->field('z.*,h.title,h.headimg,h.stime,h.lll,h.pv,h.xn_pv,h.live_type')
            ->join('vit_live_huodong h', 'z.hid=h.id')
            ->select()->toArray();

        foreach($fenlei as &$f){
            $f['zt_videos'] = [];
            foreach($ztVideoList as $zt){
                $zt['pv'] = $zt['pv'] ? $zt['pv'] : 0;
                $pv = $zt['lll']==2 ? $zt['pv'] * $zt['xn_pv'] : $zt['pv'] + $zt['xn_pv'];
                if($pv>10000){
                    $pv = sprintf("%.2f", $pv / 10000) . '万';
                }
                $zt['pv'] = $pv;
                if($zt['flid']!=$f['id']) continue;
                $f['zt_videos'][] = $zt;
            }
        }
        View::assign([
            'fenlei' => !empty($fenlei) ? $fenlei : '',
            'zhuanti' => !empty($zhuanti) ? $zhuanti : '',
            'wechatShareConfig' => $wechatShareConfig,
            'jsApiList' => $jsApiList,
            'wechatShare' => $wechatShare
        ]);
        return View::fetch();
    }
}